package labone;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 * Date: 3/21/12
 * Time: 3:04 PM
 */
public class GraphicsPrimitives {

    /*
     *  pixel
     */

    public static void putPixel(Graphics2D g, int x, int y) {
        g.drawLine(x, y, x, y);
    }

    public static void putPixel(Graphics2D g, int x, int y, Color color) {
        Color prev_color = g.getColor();
        g.setColor(color);
        putPixel(g, x, y);
        g.setColor(prev_color);
    }

    /*
     *  line
     */
    public static void drawLine(int field[][], int xfrom, int yfrom, int xto, int yto, boolean inverted) {
        //System.err.println("line: (" + xfrom + ", " + yfrom + ") - (" + xto + ", " + yto + ")");
        final int field_height = field.length;
        final int field_width  = field[0].length;

        int dx = Math.abs(xto - xfrom);
        int dy = Math.abs(yto - yfrom);

        if(dy > dx) {
            drawLine(field, -yfrom, xfrom, -yto, xto, !inverted);
            return ;
        }

        if(xto < xfrom) {
            drawLine(field, xto, yto, xfrom, yfrom, inverted);
            return ;
        }

        int direction = (yto > yfrom ? 1 : -1);
        for(int i = xfrom; i <= xto; i++) {
            double currentY = (i - xfrom) / (double)dx * dy;
            int add = (int)(currentY + .5);
            int x = inverted ? yfrom + add * direction : i;
            int y = inverted ? -i : yfrom + add * direction;
            if(0 <= y && y < field_height && 0 <= x && x <= field_width)
                field[y][x] = 0;
        }
    }

    public static void drawLine(int field[][], int xfrom, int yfrom, int xto, int yto) {
        drawLine(field, xfrom, yfrom, xto, yto, false);
    }
}
